---
title: 412 Precondition Failed
slug: Web/HTTP/Status/412
tags:
  - Error
  - HTTP
  - Reference
  - Status code
---
<div>{{HTTPSidebar}}</div>

<p>The HyperText Transfer Protocol (HTTP) <code><strong>412 Precondition Failed</strong></code> client error response code indicates that access to the target resource has been denied. This happens with conditional requests on methods other than {{HTTPMethod("GET")}} or {{HTTPMethod("HEAD")}} when the condition defined by the {{HTTPHeader("If-Unmodified-Since")}} or {{HTTPHeader("If-None-Match")}} headers is not fulfilled. In that case, the request, usually an upload or a modification of a resource, cannot be made and this error response is sent back.</p>

<h2 id="Status">Status</h2>

<pre class="syntaxbox">412 Precondition Failed</pre>

<h2 id="Examples">Examples</h2>

<pre><code>ETag: "33a64df551425fcc55e4d42a148795d9f25f89d4"
ETag: W/"0815"</code></pre>

<h3 id="Avoiding_mid-air_collisions">Avoiding mid-air collisions</h3>

<p>With the help of the <code>ETag</code> and the {{HTTPHeader("If-Match")}} headers, you can detect mid-air edit collisions.</p>

<p>For example, when editing MDN, the current wiki content is hashed and put into an <code>Etag</code> in the response:</p>

<pre><code>ETag: "33a64df551425fcc55e4d42a148795d9f25f89d4"</code></pre>

<p>When saving changes to a wiki page (posting data), the {{HTTPMethod("POST")}} request will contain the {{HTTPHeader("If-Match")}} header containing the <code>ETag</code> values to check freshness against.</p>

<pre><code>If-Match: "33a64df551425fcc55e4d42a148795d9f25f89d4"</code></pre>

<p>If the hashes don't match, it means that the document has been edited in-between and a {{HTTPStatus("412")}} <code>Precondition Failed</code> error is thrown.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7232", "412 Precondition Failed" , "4.2")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Conditional Requests</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The information below has been pulled from MDN's GitHub (<a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a>).</p>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.status.412")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPStatus("304")}}</li>
 <li>{{HTTPHeader("If-Unmodified-Since")}}</li>
 <li>{{HTTPHeader("If-None-Match")}}</li>
 <li>{{HTTPStatus("428")}}</li>
</ul>
